package deploy;

import org.apache.tools.ant.taskdefs.Echo;
import org.apache.tools.ant.taskdefs.Echo.EchoLevel;
import org.apache.tools.ant.Task;

public class CommonUtils
{

    public static final int RC_OK = 0;
    public static final int RC_ERROR = 1;
    public static final int RC_WARN = 4;


    private static Task task = null;
    private static boolean useAnt = false;


    public static void init(Task task)
    {
        this.task = task;
        useAnt = true;
    }


    public static void verbose(String msg)
    {               
        echo(msg, "verbose");
    }  


    public static void debug(String msg)
    {               
        echo(msg, "debug");
    } 


    public static void info(String msg)
    {               
        echo(msg, "info");
    }


    public static void warn(String msg)
    {               
        echo(msg, "warn");
    }


    public static void error(String msg)
    {                       
        echo(msg, "error");
    }

    
    public static void echo(String msg, String level)
    {
        if(useAnt)
        {
            Echo.EchoLevel echoLevel = new Echo.EchoLevel();
            echoLevel.setValue(level);
            Echo echo = task.getProject().createTask("echo");        
            echo.bindToOwner(task);
            echo.setMessage(level.toUpperCase() + ": " + msg);
            echo.setLevel(echoLevel);
            try
            {
                echo.perform();
            }
            catch (Throwable e)
            {
                e.printStackTrace();
            } 
        }
        else
        {
            println(level.toUpperCase() + ": " + msg);
        }               
    }
}