/**
 * 
 */
package deploy

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import com.sas.metadata.remote.MdFactory
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import com.sas.management.deployment.DeployMetadata;
import com.sas.management.deployment.DeploymentException;
import com.sas.management.deployment.MetadataUtility;
import com.sas.metadata.remote.MdException;

/**
 * @author brswee
 *
 */
public class MetadataExecution extends DeployMetadata {
    
    MdFactory my_factory = null;
    public boolean DEBUG = false;
    
    public MetadataExecution(String host, String port, String user, String password) throws RemoteException, MdException, DeploymentException
    {
        super(host, port, user, password);
        this.initialize();

    }
    
    public String getRepositoryId(String repositoryName) throws DeploymentException
    {
        return getTargetRepositoryInfo(repositoryName, false);
    }
	
	public String execute(String xmlToExecute, String type){
	    TypeHandler_groovy typeHandler = new TypeHandler_groovy(type);
	    if(null == my_factory) {
	        my_factory = this.getFactory();
	    }
//	    String result = MetadataUtility.DoRequest(my_factory, xmlToExecute);
        String result = rawExecute(xmlToExecute);
	    if(DEBUG) {
	        System.out.println("RESULT:" +result);
	    }
	    SAXParser saxParser = null;
		try {
		    saxParser = SAXParserFactory.newInstance().newSAXParser();
			saxParser.parse(new InputSource(new StringReader(result)), typeHandler);
		}
		catch (SAXException e) {
			throw new RuntimeException(e);
		}
		catch (IOException e) {
			throw new RuntimeException(e);
		}
		
		if (typeHandler.id == null) {
		    return null;
//			throw new RuntimeException("Could not find id of type: " + type + " using search: " + xmlToExecute);
		}
		if(DEBUG) {
			System.out.println("[getid] id = "+typeHandler.id);
		}
		return typeHandler.id;
	}
	
	public String getIdByName(String type, String searchString, String reposId, String flags) {
	    String xml = AddMetadata.wrapForGet(type, searchString, reposId, flags);
        if(DEBUG) {
            System.out.println(xml);
        }
        return this.execute(xml,type);
	}
	
	public String getIdByName(String type, String searchString, String reposId) {
	    //flags may need to change
	    return getIdByName(type, searchString, reposId, "8320");
	}
	
	public String rawExecute(xmlToExecute) {
	    return MetadataUtility.DoRequest(my_factory, xmlToExecute);
	}
	
}
