%macro bmfbase(
   action=create,
   appname=,
   appendLocalLog=,
   attachLocalLog=,
   attribute=,
   attributeds=,
   badnumber=,
   bmfrcvar=,
   cell=,
   cellds=,
   cellformat=,
   cellformatds=,
   clean_HttpOut=,
   converteddsdir=,
   cultureid=,
   date=,
   diagrams=,
   domain=,
   element=,
   elementds=,
   elementtypeid=,
   encoding=,
   enddate=,
   entitykey=,
   eventName=,
   filter=,
   filterds=,
   filterid=,
   guessingrows=,
   importConfig=,
   inputdir=,
   inputdslib=,
   integerkeywords=,
   invalidDirChars=,
   link=,
   linkds=,
   localEventServer=,
   migrate=,
   namevar=,
   numPeriods=,
   offset=,
   offsetend=,
   outputdir=,
   outputtype=,
   outputdslib=,
   project=,
   projectds=,
   projectid=,
   projectname=,
   pw=,
   quickentrymode=,
   quickentry=,
   quickentryds=,
   ranges=,
   rangesds=,
   range=,
   rangeds=,
   scorecard=,
   scorecardds=,
   scorecardid=,
   scorecardvar=,
   sentBy=,
   setup=,
   setupds=,
   softwarecomponent=,
   sort=,
   synchronous=,
   templatename=,
   user=,
   version=
);

   %global eventserver debug;

   %put NOTE: &appname &version;

   %local props prop_vals scorecardprop attributeprop elementprop cellprop cellformatprop
          setupprop linksprop test;
   %local projectprop rangesprop filterprop teststr delim outputdirslash setupoutputdirslash
          tmpFile diagramsprop quickentryprop;
   %local setupinputdirslash inputdirslash slash diagramds;

   %let diagramds=;

   /* set the slash direction based on whether the OUTPUTDIR has forward or backward slashes.  If a slash cannot be found
      then base it on the OS of where the macro is running. */
   %if %index(&outputdir,\) > 0 %then %do;
      %let slash = \;
   %end;
   %else %if %index(&outputdir,/) > 0 %then %do;
      %let slash = /;
   %end;
   %else %if &sysscp=WIN %then %let slash=\;
   %else %let slash=/;


   /* must specify a user and pw */
   %if %bquote(&user) = %str() %then %do;
      %put ERROR: &appname &version - Cannot run &appname without specifying a user. ;
      %goto bmferror;
   %end;
   %if %bquote(&pw) = %str() %then %do;
      %put ERROR: &appname &version - Cannot run &appname without specifying a password.;
      %goto bmferror;
   %end;

   /* make project and template names safe for path names */
   %local alterredprojectname alterredtemplatename;
   %convertbaddirchars(inchars=&projectname,outvar=alterredprojectname,invalidchars=%bquote(&invalidDirChars));
   %if %bquote(&projectname) ne %bquote(&alterredprojectname) %then %do;
      %put NOTE: Project Name: %bquote(&projectname) has been converted to %bquote(&alterredprojectname) for use with directory naming.;
   %end;
   %convertbaddirchars(inchars=&templatename,outvar=alterredtemplatename,invalidchars=%bquote(&invalidDirChars));
   %if %bquote(&templatename) ne %bquote(&alterredtemplatename) %then %do;
      %put NOTE: Template Name: %quote(&templatename) has been converted to %bquote(&alterredtemplatename) for use with directory naming.;
   %end;

   /* shape up the outputdir */
   %let outputdir=%bquote(&outputdir);
   %if %bquote(&outputdir) = %str() %then %do;
      %put ERROR: Cannot run &appname with a blank output dir. ;
      %goto bmferror;
   %end;
   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): outputdir = &outputdir;
   %end;
   %if %index(%substr(&outputdir,%length(&outputdir),1),&slash) = 0 %then %do;
      %let outputdirslash = %trim(&outputdir)&slash;
   %end;
   %else %do;
      %let outputdirslash = &outputdir;
      %let outputdir = %substr(&outputdir,1,%eval(%length(&outputdir)-1));
   %end;

   /* add template name to the end of the outputdir since that is where the setup file */
   /* will be output to */
   %let setupoutputdirslash = %trim(&outputdirslash)%trim(&alterredtemplatename)&slash;
   /* add template name and project name to end of the outputdir since that is now the */
   /* root of the output from the midtier code. */
   %let outputdirslash = %trim(&setupoutputdirslash)%trim(&alterredprojectname)&slash;
   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): setupoutputdirslash = &setupoutputdirslash;
      %put %str( );
      %put NOTE: &appname(DEBUG): outputdirslash = &outputdirslash;
   %end;

   /* clean up the inputdir */
   %let inputdir=%nrbquote(&inputdir);
   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): inputdir = &inputdir;
   %end;
   %if %nrbquote(&inputdir) ne %str() %then %do;
      %if %index(&inputdir,\) > 0 %then %do;
         %let delim = \;
      %end;
      %else %do;
         %let delim = /;
      %end;
      %if %index(%substr(&inputdir,%length(&inputdir),1),&delim) = 0 %then %do;
         %let inputdirslash = %trim(&inputdir)&delim;
      %end;
      %else %do;
         %let inputdirslash = &inputdir;
         %let inputdir = %substr(&inputdir,1,%eval(%length(&inputdir)-1));
      %end;
      /* add template name to the end of the inputdir since that is where the setup */
      /* file will be input from */
      %let setupinputdirslash = %trim(&inputdirslash)%trim(&alterredtemplatename)&delim;
      /* add template name and project name to end of the inputdir since that is now */
      /* the root of the input from the midtier code. */
      %let inputdirslash = %trim(&setupinputdirslash)%trim(&alterredprojectname)&delim;
   %end;
   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): setupinputdirslash = &setupinputdirslash;
      %put %str( );
      %put NOTE: &appname(DEBUG): inputdirslash = &inputdirslash;
   %end;


   /* get the event server */

   /* set metauser and metapass options to the SPM user/pw if the metauser option */
   /* has not already been set */
   %let teststr = %sysfunc(getoption(metauser));
   %if %bquote(&teststr) = %str() %then %do;
      options metauser="&user" metapass="&pw";
   %end;

   /* if there is not a supplied eventserver then get one */
   %if &localEventServer = %str() %then %do;
      /* get a valid event listener to send the event to */
      %getstmc();
   %end;
   %else %do;
      /* if there is one, then assign it to a local copy of EVENTSERVER */
      %local eventserver;
      %let eventserver=&localEventServer;
   %end;

   /* if there is still no event server then abort */
   %if %bquote(&EVENTSERVER) = %str() %then %do;
      %put ERROR: Cannot run &appname without an event server. ;
      %goto bmferror;
   %end;
   %else %if %bquote(&debug) = %str(Y) %then %do;
      %put NOTE: &appname(DEBUG): EVENTSERVER = &EVENTSERVER;
   %end;


   %if %upcase(%bquote(&action))=CREATE or %bquote(&action)=MODIFY %then %do;
      /* If no input files or datasets are specified, default to files in the INPUTDIR directory if they are present. */
      /* If the input directory csv files are not there, and there is an INPUTDSLIB defined, and a dataset is  */
      /* there, then use the dataset as input. */
      %assignInput(&scorecardds, &scorecard, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Scorecard)
      %assignInput(&elementds, &element, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Element)
      %assignInput(&attributeds, &attribute, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Attribute)
      %assignInput(&cellds, &cell, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Cell)
      %assignInput(&projectds, &project, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Project)

      %assignInput(&diagramds, &diagrams, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Diagrams)

      %assignInput(&rangesds, &ranges, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Range)
      /* this is an attempt to correct the fact that initially the parameter RANGES was used
      /* when it should have been RANGE. */
      %if %bquote(&range) ne %str() %then %let ranges = &range;
      %if %bquote(&rangeds) ne %str() %then %let rangesds = &rangeds;

      %assignInput(&filterds, &filter, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Filter)
      %assignInput(&cellformatds, &cellformat, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Cellformat)
      %assignInput(&linkds, &link, &inputdirslash&alterredprojectname, &alterredprojectname, &inputdslib, Link)
      %assignInput(&setupds, &setup, &setupinputdirslash&alterredtemplatename, &alterredtemplatename, &inputdslib, Setup)
   %end;




   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): scorecard: &scorecard;
      %put NOTE: &appname(DEBUG): element = &element;
      %put NOTE: &appname(DEBUG): cell = &cell;
      %put NOTE: &appname(DEBUG): setup = &setup;
      %put NOTE: &appname(DEBUG): project = &project;
      %put NOTE: &appname(DEBUG): ranges = &ranges;
      %put NOTE: &appname(DEBUG): filter = &filter;
      %put NOTE: &appname(DEBUG): cellformat = &cellformat;
      %put NOTE: &appname(DEBUG): link = &link;
      %put NOTE: &appname(DEBUG): quickentry = &quickentry;
      %put NOTE: &appname(DEBUG): integerkeywords = &integerkeywords;
      %put NOTE: &appname(DEBUG): scorecardds = &scorecardds;
      %put NOTE: &appname(DEBUG): elementds = &elementds;
      %put NOTE: &appname(DEBUG): cellds = &cellds;
      %put NOTE: &appname(DEBUG): setupds = &setupds;
      %put NOTE: &appname(DEBUG): projectds = &projectds;
      %put NOTE: &appname(DEBUG): rangesds = &rangesds;
      %put NOTE: &appname(DEBUG): filterds = &filterds;
      %put NOTE: &appname(DEBUG): cellformatds = &cellformatds;
      %put NOTE: &appname(DEBUG): quickentryds = &quickentryds;
      %put NOTE: &appname(DEBUG): importConfig = &importConfig;
   %end;

   /* check for diagram input */
   %if %bquote(&diagrams) ne %str() %then %do;
      %let diagramsprop=diagrams;
      %if %bquote(&debug) = %str(Y) %then %do;
         %put NOTE: &appname(DEBUG): diagram input = &diagrams;
      %end;
   %end;

   /* set up the property variable for each type with the correct input file path */
   %setInputProperty(file=&scorecard,   sasds=&scorecardds,    propertyVariable=scorecardprop,  type=scorecard,  dummyrow=Y)
   %setInputProperty(file=&attribute,   sasds=&attributeds,    propertyVariable=attributeprop,  type=attribute,  dummyrow=Y)
   %setInputProperty(file=&element,     sasds=&elementds,      propertyVariable=elementprop,    type=element,    dummyrow=Y)
   %setInputProperty(file=&cellformat,  sasds=&cellformatds,   propertyVariable=cellformatprop, type=cellformat, dummyrow=N)
   %setInputProperty(file=&link,        sasds=&linkds,         propertyVariable=linksprop,      type=link,       dummyrow=N)
   %setInputProperty(file=&cell,        sasds=&cellds,         propertyVariable=cellprop,       type=cell,       dummyrow=Y)
   %setInputProperty(file=&setup,       sasds=&setupds,        propertyVariable=setupprop,      type=setup,      dummyrow=N)
   %setInputProperty(file=&ranges,      sasds=&rangesds,       propertyVariable=rangesprop,     type=ranges,     dummyrow=N)
   %setInputProperty(file=&filter,      sasds=&filterds,       propertyVariable=filterprop,     type=filterfile, dummyrow=N)
   %setInputProperty(file=&project,     sasds=&projectds,      propertyVariable=projectprop,    type=project,    dummyrow=N)
   %setInputProperty(file=&quickentry,  sasds=&quickentryds,   propertyVariable=quickentryprop, type=quickentry, dummyrow=Y)

   /* set the caller name */
   %if %bquote(&sentby) = %str() %then %let sentby=&appname.Caller;

   /* set the eventname and synchronous flag */
   %local defaultEventName defaultSyncEventName;
   %let defaultEventName =SAS.Solutions.SpmBOBInterface;
   %let defaultSyncEventName =SAS.Solutions.SpmBOBInterfaceSynch;

   %if %bquote(&synchronous)= Y or %bquote(&synchronous) = YES or %bquote(&synchronous) = 1 %then %do;
      %if %bquote(&eventname)=%str() %then %do;
         %let eventName=&defaultSyncEventName;
         %let synchronous=Y;
      %end;
      %else %if %bquote(&eventname)= &defaultEventName %then
         %let synchronous = N;
   %end;
   %else %do;
      %if %bquote(&eventname)=%str() %then %do;
         %let eventName=&defaultEventName;
         %let synchronous = N;
      %end;
      %else %if %bquote(&eventName) = &defaultSyncEventName %then %do;
         %let synchronous = Y;
      %end;
      %else %let synchronous = N;
   %end;
   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): synchronous = &synchronous;
      %put NOTE: &appname(DEBUG): eventName = &eventName;
   %end;

   /* construct the event properties */
   %let sendevnt_delimiter=%str(^);

   /* Construct the event properties. Note that these names must correspond exactly to the constants found
      in com.sas.solutions.spm.core.data.DataConst.java                                                    */
   %let props=outputdir;
   %let props=&props outputtype;
   %let props=&props bobuser;
   %let props=&props sentby;
   %let props=&props pw;
   %let props=&props entitykey;
   %let props=&props action;
   %let props=&props migrate;
   %let props=&props quickentrymode;
   %let props=&props appendLocalLog;
   %let props=&props attachLocalLog;

   %let prop_vals=&outputdir&sendevnt_delimiter;
   %let prop_vals=&prop_vals&outputtype&sendevnt_delimiter;
   %let prop_vals=&prop_vals&user&sendevnt_delimiter;
   %let prop_vals=&prop_vals&sentby&sendevnt_delimiter;
   %let prop_vals=&prop_vals&pw&sendevnt_delimiter;
   %let prop_vals=&prop_vals&entitykey&sendevnt_delimiter;
   %let prop_vals=&prop_vals&action&sendevnt_delimiter;
   %let prop_vals=&prop_vals&migrate&sendevnt_delimiter;
   %let prop_vals=&prop_vals&quickentrymode&sendevnt_delimiter;
   %let prop_vals=&prop_vals&appendLocalLog&sendevnt_delimiter;
   %let prop_vals=&prop_vals&attachLocalLog;


   /* add the event coding only if there is a value */
   %let encoding=%qupcase(&encoding);
   %if %bquote(&encoding) ne %str() %then %do;
     %let props=&props encodeOutput;
     %let prop_vals=&prop_vals&sendevnt_delimiter&encoding;
   %end;

   /* add integer keywords only if there is a value */
   %if %bquote(&integerkeywords) ne %str() %then %do;
     %let props=&props integerkeywords;
     %let prop_vals=&prop_vals&sendevnt_delimiter&integerkeywords;
   %end;

   /* add import config only if there is a value */
   %if %bquote(&importConfig) ne %str() %then %do;
        %let props=&props importConfig;
        %let prop_vals=&prop_vals&sendevnt_delimiter&importConfig;
   %end;

   /* add setup csv file if present. */
   %addpropname(propname=%nrbquote(&setupprop),propval=%nrbquote(&setup))
   /* add project csv file if present. */
   %addpropname(propname=%nrbquote(&projectprop),propval=%nrbquote(&project))
   /* add range csv file if present. */
   %addpropname(propname=%nrbquote(&rangesprop),propval=%nrbquote(&ranges))
   /* add diagram file if present. */
   %addpropname(propname=%nrbquote(&diagramsprop),propval=%nrbquote(&diagrams))
   /* add scorecard csv file if present. */
   %addpropname(propname=%nrbquote(&scorecardprop),propval=%nrbquote(&scorecard))
   /* add element csv file if present. */
   %addpropname(propname=%nrbquote(&elementprop),propval=%nrbquote(&element))
   /* add attribute csv file if present. */
   %addpropname(propname=%nrbquote(&attributeprop),propval=%nrbquote(&attribute))
   /* add cell csv file if present. */
   %addpropname(propname=%nrbquote(&cellprop),propval=%nrbquote(&cell))
   /* add cell format csv file if present. */
   %addpropname(propname=%nrbquote(&cellformatprop),propval=%nrbquote(&cellformat))
   /* add links csv file if present. */
   %addpropname(propname=%nrbquote(&linksprop),propval=%nrbquote(&link))
   /* add quickentry csv file if present. */
   %addpropname(propname=%nrbquote(&quickentryprop),propval=%nrbquote(&quickentry))
   /* add filter csv file if present. */
   %addpropname(propname=%nrbquote(&filterprop),propval=%nrbquote(&filter))

   /* add domain if present. */
   %addpropname(propname=bobdomain,propval=%nrbquote(&domain),valcheck=Y)
   /* add projectid if present. */
   %addpropname(propname=projectid,propval=%nrbquote(&projectid),valcheck=Y)
   /* add scorecardid if present. */
   %addpropname(propname=scorecardid,propval=%nrbquote(&scorecardid),valcheck=Y)
   /* add elementtypeid if present. */
   %addpropname(propname=elementtypeid,propval=%nrbquote(&elementtypeid),valcheck=Y)
   /* add date if present. */
   %addpropname(propname=date,propval=%nrbquote(&date),valcheck=Y)
   /* add enddate if present. */
   %addpropname(propname=enddate,propval=%nrbquote(&enddate),valcheck=Y)
   /* add offset if present. */
   %addpropname(propname=offset,propval=%nrbquote(&offset),valcheck=Y)
   /* add offsetend if present. */
   %addpropname(propname=offsetend,propval=%nrbquote(&offsetend),valcheck=Y)
   /* add numPeriods if present. */
   %addpropname(propname=numPeriods,propval=%nrbquote(&numPeriods),valcheck=Y)
   /* add sort if present. */
   %addpropname(propname=sort,propval=%nrbquote(&sort),valcheck=Y)
   /* add filterid if present. */
   %addpropname(propname=filterid,propval=%nrbquote(&filterid),valcheck=Y)
   /* add cultureid if present. */
   %addpropname(propname=cultureid,propval=%nrbquote(&cultureid),valcheck=Y)
   /* add projectname if present. */
   %addpropname(propname=projectname,propval=%nrbquote(&projectname),valcheck=Y)
   /* add templatename if present. */
   %addpropname(propname=templatename,propval=%nrbquote(&templatename),valcheck=Y)
   /* add namevar if present. */
   %addpropname(propname=namevar,propval=%nrbquote(&namevar),valcheck=Y)
   /* add scorecardvar if present. */
   %addpropname(propname=scorecardvar,propval=%nrbquote(&scorecardvar),valcheck=Y)
   /* add badnumber if present. */
   %addpropname(propname=badnumber,propval=%nrbquote(&badnumber),valcheck=Y)
   /* add invalid directory characters if present. */
   %addpropname(propname=invalidDirChars,propval=%nrbquote(&invalidDirChars),valcheck=Y)


   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): props = &props;
      %put %str( );
      %put NOTE: &appname(DEBUG): prop_vals = &prop_vals;
   %end;

   /* run the event either synchronously or asynchronously */
   %local result_url result_rc;
   %let result_rc=0;
   %if &synchronous=Y %then %do;
      filename foo temp;
      %let result_url = %bquote(%sysfunc(pathname(foo)));
      %if %bquote(&debug) = %str(Y) %then %do;
         %put %str( );
         %put NOTE: &appname(DEBUG): Sending synchronous event;
      %end;

      %sendrqst(evntname=&eventName,
         eventserver=&EVENTSERVER/xml/BMFEndpoint,
         sentby=&sentby,
         response=RESULT,
         result_url=&result_url,
         vals_delimiters=&sendevnt_delimiter,
         props=%bquote(&props),
         vals=%bquote(&prop_vals),
         clean_HttpOut=&clean_HttpOut,
         encoding=&encoding
      )
   %end;
   %else %do;
      %if %bquote(&debug) = %str(Y) %then %do;
         %put %str( );
         %put NOTE: &appname(DEBUG): Sending asynchronous event;
      %end;
      %sendrqst(evntname=&eventName,
         eventserver=&EVENTSERVER/xml/BMFEndpoint,
         sentby=&sentby,
         vals_delimiters=&sendevnt_delimiter,
         props=%bquote(&props),
         vals=%bquote(&prop_vals),
         clean_HttpOut=&clean_HttpOut,
         encoding=&encoding
      )
   %end;

   /* check to see if csv output needs to be converted to datasets */
   %if &synchronous = Y and %bquote(&outputdslib) ne %str() %then %do;
      %if %sysfunc(libref(%bquote(&outputdslib))) ne 0 %then %do;
         %put WARNING: %upcase(%bquote(&outputdslib)) is not assigned, cannot create output SAS data sets.;
      %end;
      %else %do;

         %local safeTemplateName safeProjectName;
	
	    %let safeTemplateName =;
	    %let safeProjectName =;
	
	    %do i=1 %to %length(&templatename);
	      %if %bquote(%substr(&templatename,&i,1)) = %str()
	      %then %let safeTemplateName = &safeTemplateName%bquote(_);
	      %else %let safeTemplateName = &safeTemplateName%bquote(%substr(&templatename,&i,1));
	    %end;
	 	
	  %do i=1 %to %length(&projectname);
	    %if %bquote(%substr(&projectname,&i,1)) = %str()
	    %then %let safeProjectName = &safeProjectName%bquote(_);
	    %else %let safeProjectName = &safeProjectName%bquote(%substr(&projectname,&i,1));
	 %end;
	
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._Scorecard.csv,sasds=&outputdslib..&alterredprojectname._Scorecard,
               guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._Element.csv,sasds=&outputdslib..&alterredprojectname._Element,
              guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._Attribute.csv,sasds=&outputdslib..&alterredprojectname._Attribute,
               guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._Cell.csv,sasds=&outputdslib..&alterredprojectname._Cell,
               guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._CellFormat.csv,sasds=&outputdslib..&alterredprojectname._CellFormat,
               guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._Link.csv,sasds=&outputdslib..&alterredprojectname._Link,
               guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._Range.csv,sasds=&outputdslib..&alterredprojectname._Range,
               guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeTemplateName._Setup.csv,sasds=&outputdslib..&alterredtemplatename._Setup,
               guessingrows=&guessingrows)
         %procimport(csvpath=&outputdir&slash&safeTemplateName&slash&safeProjectName&slash&&safeProjectName._Project.csv,sasds=&outputdslib..&alterredprojectname._Project,
               guessingrows=&guessingrows)
      %end;
   %end;

   %local loglocation;
   %let loglocation = Additional &appname &version notes can be found in &outputdir&slash&templatename&slash&templatename._log.txt;
   %if &synchronous ne Y %then %do;
      %put NOTE: &appname &version has ended but some &appname processes may still be running asynchronously.;
      %put NOTE: &loglocation;
   %end;
   %else %do;
      %put NOTE: &appname &version ended successfully;
      %put NOTE: &loglocation;


   %end;
   %goto exit;

   %bmferror:
   %put NOTE: &appname &version ended with errors.;
   %exit:

%mend;



%macro addpropname(propname=,propval=,valcheck=);
   /* Adds &propname to the props string.  Adds &propval to the prop_vals string. */
   /* valcheck= controls whether the operation is based on a non blank value or non-blank property name */
   %if (%nrbquote(&valcheck) eq Y and %nrbquote(&propval) ne %str()) or
      (%nrbquote(&valcheck) ne Y and %nrbquote(&propname) ne %str()) %then %do;
      %let props=&props %nrbquote(&propname);
      %let prop_vals=&prop_vals&sendevnt_delimiter%nrbquote(&propval);
   %end;
%mend;


%macro assignInput(dsvar, nondsvar, fileprefix, libprefix, inputdslib, type);
   /* assign a file to &type if there is not one already specified */

   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: assignInput(DEBUG): dsvar=&dsvar, nondsvar=&nondsvar, fileprefix=&fileprefix, libprefix=&libprefix, inputdslib=&inputdslib, type=&type;
   %end;



   /* if there is no file or SAS DS specification then check if there is a file in the inputdirectory */
   %if %bquote(&dsvar) = %str() and %bquote(&nondsvar) = %str() %then %do;

      /* Check for any existing CSV file first */
      %if %sysfunc(fileexist(&fileprefix._&type..csv)) %then %do;
         %let &type=&fileprefix._&type..csv;
         %if %bquote(&debug) = %str(Y) %then %do;
            %put NOTE: assignInput(DEBUG): &fileprefix._&type..csv: fileexist = %sysfunc(fileexist(&fileprefix._&type..csv));
         %end;
      %end;

      /* Now check for any XML file (for diagrams) */
      %else %if %sysfunc(fileexist(&fileprefix._&type..xml)) %then %do;
        %let &type=&fileprefix._&type..xml;
        %if %bquote(&debug) = %str(Y) %then %do;
          %put NOTE: assignInput(DEBUG): &fileprefix._&type..xml: fileexist = %sysfunc(fileexist(&fileprefix._&type..xml));
          %end;
      %end;

      /* then check if a SAS data set exists in the supplied libref */
      %else %if %sysfunc(exist(&inputdslib..&libprefix._&type))=1 %then %do;
          %let &type.ds=&inputdslib..&libprefix._&type;
          %if %bquote(&debug) = %str(Y) %then %do;
             %put NOTE: assignInput(DEBUG): &inputdslib..&libprefix._&type: exist = %sysfunc(exist(&inputdslib..&libprefix._&type));
          %end;
      %end;
   %end;

%mend;

%macro procimport(csvpath=,sasds=,guessingrows=32767);
   /* converts a csv file name in &csvpath to a sas data set name in &sasds */
   %if %bquote(&debug) = %str(Y) %then %do;
      %put NOTE: &appname(DEBUG): Converting csv file to SAS datasets.;
      %put NOTE: &appname(DEBUG): csv: &csvpath;
      %put NOTE: &appname(DEBUG): sasds: &sasds;
   %end;

   %if %sysfunc(fileexist(&csvpath)) = 0 %then %do;
      %if %bquote(&debug) = %str(Y) %then %do;
         %put WARNING: &appname(DEBUG): &csvpath does not exist.;
      %end;
   %end;

   %else %do;
      /* source is being turned off because PROC IMPORT produces a lot of generated source */
      %if %bquote(&debug) ne Y %then %do;
         options nosource;
      %end;
      proc import DATAFILE="&csvpath" OUT=&sasds DBMS=CSV REPLACE;
         guessingrows=&guessingrows;
      run;
      %if %bquote(&debug) ne Y %then %do;
         options source;
      %end;
   %end;
%mend;


%macro setInputProperty(file=, sasds=, propertyVariable=, type=, dummyRow=Y);
   /* set the inputfile for the input type.  The file can be either a CSV file or SAS ds.  */
   /* If it is a SAS ds then it will be converted to a CSV file */
   /* file = the name of the input CSV file for this type. */
   /* sasds = the name of the SAS ds.  This will be converted to CSV file */
   /* propertyVariable = the name of the macro variable that will hold the path to the CSV file */
   /* type = the input file type, i.e.  scorecard or cell or setup or element, etc. */

   /* if there is no specified CSV file */
   %if %bquote(&file) = %str() %then %do;
      /* and if there is no specified SAS data set, then return */
      %if %bquote(&sasds) = %str() %then %do;
         /* no data set either */
         %let &propertyVariable=;
         %if %bquote(&debug) = %str(Y) %then %do;
            %put NOTE: &appname(DEBUG): No &type input;
         %end;
      %end;
      /* if there is a specified SAS ds */
      %else %do;
         /* set up a macro variable by the same name as the type.  This will be used */
         /* later to add the property to the list to be published */
         %let &propertyVariable=&type;
         /* convert the SAS ds to a CSV file */
         %createCSVInputFile(ds=&sasds, returnvar=tmpFile, path=&converteddsdir,dummyRow=&dummyRow)
         %let &type=&tmpFile;
         %if %bquote(&debug) = %str(Y) %then %do;
            %put NOTE: &appname(DEBUG): &type input from SAS dataset written to csv: &&&type;
         %end;
      %end;
   %end;
   /* there is a specified CSV file, so use it */
   %else %do;
      %let &propertyVariable=&type;
      %if %bquote(&debug) = %str(Y) %then %do;
         %put NOTE: &appname(DEBUG): &type input: &file;
      %end;
   %end;
%mend;


%macro createCSVInputFile(ds=, returnvar=, path=, dummyRow=N);
   /* Creates a CSV file based on an input SAS ds and returns the complete path    */
   /*  and filename of the CSV file                                                */
   /*     ds = name of the SAS data set to be used as the basis for conversion     */
   /*     returnvar = the macro variable that will hold the completed path         */
   /*     path = the directory where the CSV file will be created                  */
   /*     dummyRow = used only by the IMAP facility, not documented here           */
   %if %bquote(&debug) = %str(Y) %then %do;
      %put %str( );
      %put NOTE: &appname(DEBUG): Converting SAS dataset %upcase(&ds) to CSV file %upcase(&ds).CSV.;
      %if %bquote(&path) = %str() %then %put NOTE: &appname(DEBUG): No path specified, default will be used.;
      %else %put NOTE: &appname(DEBUG): CSV path is &path..;
   %end;

   %local i word source notes optname fid slash;

    /* set the slash direction based on whether the PATH has forward or backward slashes.  If a slash cannot be found
       then base it on the OS of where the macro is running. */

    %if %index(&path,\) > 0 %then %do;
       %let slash = \;
    %end;
    %else %if %index(&path,/) > 0 %then %do;
       %let slash = /;
    %end;
    %else %if &sysscp=WIN %then %let slash=\;
    %else %let slash=/;

   %if %bquote(&path) = %str() %then %do;
      /* use a default path. This will only work on a single tier setup */
      %if &sysscp=WIN %then
      %let &returnvar = !SASROOT/scorecard/sasmisc/&ds..csv;
      %else
      %let &returnvar = !SASROOT/misc/scorecard/&ds..csv;
      %if %bquote(&debug) = %str(Y) %then %do;
         %put WARNING: &appname(DEBUG): Default CSV file location of &&&returnvar will be used.  Verify that this is a valid path for the BMF server.;
      %end;
   %end;
   /* otherwise combine the path and the csv file name.  The csv file will be the sas ds name */
   /* plus the .csv extension.  */
   %else %do;
      /* if necessary, add a slash at the end of the path */
      %let test = %substr(&path, %length(&path), 1);
      %if %bquote(&test) = %str(/) or %bquote(&test) = %str(\) %then %do;
         %let &returnvar=&path.&ds..csv;
      %end;
      %else %do;
         %let &returnvar=&path&slash&ds..csv;
      %end;
   %end;

   /* begin the conversion */

   /* get full, resolved path name */
   filename tmpfile "&&&returnvar";
   %let fid=%sysfunc(fopen(tmpfile));
   %if &fid gt 0 %then %do;
      %let optname=%sysfunc(foptname(&fid, 1));
      %let &returnvar=%sysfunc(finfo(&fid,&optname));
      %let fid=%sysfunc(fclose(&fid));
   %end;

   options nonotes;
   filename tmpfile clear;
   options notes;

   %getvars(dsname=&ds);

   options notes missing=' ';
   %let rc=0;
   data _null_;
      set &ds end=end;
      file "&&&returnvar" LINESIZE=32767;

      /* put out a dummy record at the top since java will discard it. */
      dummyRow = "&dummyRow";
      if _N_ = 1 & dummyRow="Y" then do;
         put "please ignore this row, BMF will consume it later.";
      end;

      /* generate appropriate put statement for each variable */
      %let i = 1;
      %do %until (&word=%str());
         %let word=%scan(&vars, &i, %str( ));
         %if &word ne %str() %then %do;
            if missing(&word) then
            put ',' @;
            else
            put '"' &word +(-1)'",' @;
         %end;
         %let i = %eval(&i + 1);
      %end;
      put +(-1)' ';
      if end then call symput('RC','1');
   run;
   %if &rc = 0 %then %do;
      %put ERROR: BMF is not able to convert SAS data set &ds to &&&returnvar;
   %end;
   %if %bquote(&debug) = %str(Y) %then %do;
      %put NOTE: Successfully created &&&returnvar..;
   %end;
   %exit:

   options missing='.';

%mend;

%macro getvars(dsname=,pw=);
   %local i n;
   %global vars;
   %let n=0;
   %let vars=;
   %if &pw ne %then %let pw=read=&pw;
   options nodsnferr nonotes nosource;
   proc contents varnum data=&dsname(&pw) noprint out=_varlst_(keep=name varnum);
   run;
   proc sort data=_varlst_; by varnum;
   run;
   data _null_;
      set _varlst_ end=end;
      call symput('n'!!left(put(_n_,3.)),name);
      if end then call symput('n',left(put(_n_,3.)));
   run;
   proc datasets lib=work nolist;delete _varlst_;quit;
   run;
   options &notes &source;
   %do i=1 %to &n;
      %let vars=%trim(&vars) &&n&i;
   %end;
   %let vars=%str( &vars );
   options notes source;
%mend;

%macro convertbaddirchars(inchars=,outvar=,invalidChars=);
     /* converts any invalid characters in the INCHARS parameter and stores the result */
     /* in the variables defined in the OUTVAR parameter.  Invalid characters are  */
     /* defined as those in the INVALIDCHARS parameter. */
     %if &outvar ne %str() %then %do;
       %if %nrbquote(&invalidChars) = %str() %then
         %let invalidChars=%str( !@#$%^&*()+-={}|[]\:<>?,./''"");
       %local convert;
       /* the convert string must be as leaset as long as the invalid chars string */
       %let convert=%sysfunc(repeat(_,%length(&invalidChars)));

       %if %length(%nrbquote(&inchars)) > 0 %then %do;
          %let &outvar = %sysfunc(translate(%nrbquote(&inchars), &convert, &invalidChars));
       %end;
       %else %do;
         %let &outvar = %str();
       %end;
     %end;
%mend;
